<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <title>Inline Functions as Methods</title>
</head>
  <script type="text/javascript">
    function Distance (r, t) {//Constructorfunction
      this.rate = r; 
      this.time = t;
      this.calculate = function() {return r * t ; } // anonymous
    }
  </script>
  <body>
    <script type ="text/javascript"> 
      var trip1=new Distance(50,1.5); 
      var trip2=new Distance(75,3.2); 
      alert("trip 1 distance: "+ trip1.calculate());
      alert("trip 2 distance: "+ trip2.calculate());
    </script> 
  </body>
  
  <!--
  1 This is the constructor function for the Distanceclass. It takes two parameters, r and t, 
    and returns a reference to an object. 
  
  2 Properties are assigned to the object. The this keyword is a reference to the current object.
  
  3 When a function is assigned to a property, it is called a method. This is an inline or anonymous function.
    It has no name but has been defined and assigned to the object as a method.
     
  4 A new object called trip1is created with the newconstructor. Two arguments are passed, the rate (how fast)
    and the time (in hours). This is the first instance of the Distanceclass.
  
  5 Another object, trip2, is created and sends different argument values.

  6 See Figure 8.7. The method called calculate()is invoked for each object. 
    The alert box displays the value returned from the calculate()method; that is, the distance traveled.
  -->
</html>